; Gestion d'alarme pour transmetteur GSM
;
; Fait par Aurlien ROBERT
; 10/2001

; GPIO0 : contact detecteur
; GPIO1 : contact detecteur
; GPIO2 : sortie electro aimant
; GPIO3 : dipswitch LSb
; GPIO4 : dipswitch MSb
; GPIO5 : sortie ampli

	list p=12c508a
	include <p12c508a.inc>

	__CONFIG _WDT_OFF & _IntRC_OSC & _MCLRE_OFF & _CP_ON

	cblock	0x07
		t1
		t2
		t3
		nbimp
		PDel0
		PDel1
		PDel2
	endc

	org	0x00
	movwf	OSCCAL		; chargement osccal
	movlw	B'00011011'		; GPIO2 en sortie, le reste en entree
	movwf	TRIS
	movlw	B'00001111'		; pinchange, pullup, pas timer
	movwf	OPTION
	btfsc	STATUS,GPWUF	; test origine reset
	goto	alarme
	bcf	GPIO,2		; init sorties
	bcf	GPIO,5
	movlw	D'20'
	movwf	t1
temp1	call	tempo1sec		; premiere tempo de 20 secondes entre
	decfsz	t1,f
	goto	temp1
	movf	GPIO,w
	sleep			; en attente alarme

alarme	movlw	D'6'
	movwf	t2
temp2	call	tempo1sec		; tempo 6 secondes avant alarme
	decfsz	t2,f
	goto	temp2
	movf	GPIO,w
	movwf	nbimp		; nbe impulsions sur bits 3:4
	rrf	nbimp,f		; 2:3
	rrf	nbimp,f		; 1:2
	rrf	nbimp,f		; 0:1
	movlw	B'00000011'
	andwf	nbimp,f		; on ne garde que le resultat en nbe impulsions, de 0  3 impulsions...
	incf	nbimp,f
	incf	nbimp,f		; on ajoute deux : pour avoir le choix entre 2 et 5 impulsions
sendimp	bsf	GPIO,2		; cycle electroaimant
	call	tempo1sec
	bcf	GPIO,2
	call	tempo1sec
	call	tempo1sec
	decfsz	nbimp,f		; si nbe impulsions atteint, on s'en va
	goto	sendimp
	bsf	GPIO,5		; on lance l'ampli
	movlw	D'40'
	movwf	t3
temp3	call	tempo1sec		; tempo 40 secondes appel
	decfsz	t3,f
	goto	temp3	
	bcf	STATUS,GPWUF
	bcf	GPIO,5		; on eteint l'ampli
	movf	GPIO,w
	sleep			; on se remet en attente

tempo1sec	movlw	D'14'		; temporisation de 1 seconde
	movwf	PDel0
PLoop0	movlw	D'72'
	movwf	PDel1
PLoop1	movlw	D'247'
	movwf	PDel2
PLoop2	clrwdt
	decfsz	PDel2,f
	goto	PLoop2
	decfsz	PDel1,f
	goto	PLoop1
	decfsz	PDel0,f
	goto	PLoop0
PDelL1	goto	PDelL2
PDelL2	clrwdt
	return

	END	
